<!DOCTYPE html>
<html lang="zh-CN">
    <head>
        <meta charset="UTF-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>重复请求问题</title>
    </head>

    <body>
        <button>点击发送</button>
        <script>
            //获取元素对象
            const btns = document.querySelectorAll("button");
            let x = new XMLHttpRequest();
            //标识变量
            let isSending = false; // 是否正在发送AJAX请求

            btns[0].onclick = function () {
                //判断标识变量
                if (isSending) x.abort(); // 如果正在发送，则取消原请求，发起新请求
                x.open("GET", "http://127.0.0.1:8000/delay");
                x.onreadystatechange = function () {
                    if (x.readyState === 4) {
                        //修改标识变量
                        isSending = false;
                    }
                };
                x.send();
                //修改 标识变量的值
                isSending = true;
            };

            // abort
            btns[1].onclick = function () {
                x.abort();
            };
        </script>
    </body>
</html>
